apiVersion: argoproj.io/v1alpha1
kind: Workflow
metadata:
  generateName: "kg-min-working-example"
  namespace: "argo"
spec:
  entrypoint: kg-min-working-example
  templates:
  - name: kg-min-working-example
    dag:
      tasks:
      - name: blazegraph
        template: blazegraph

      - name: data-uploader
        template: data-uploader
        dependencies: ["blazegraph"]
        arguments:
          parameters:
          - name: kg-endpoint
            value: "http://{{tasks.blazegraph.ip}}:8080/blazegraph/namespace/kb/sparql"

      - name: data-downloader
        template: data-downloader
        dependencies: ["data-uploader"]
        arguments:
          parameters:
          - name: kg-endpoint
            value: "http://{{tasks.blazegraph.ip}}:8080/blazegraph/namespace/kb/sparql"

  - name: blazegraph
    daemon: true
    container:
      image: localhost/blazegraph:1.0.0
      command: [ "catalina.sh", "run" ]
      readinessProbe:
        httpGet:
          path: /blazegraph
          port: 8080
        initialDelaySeconds: 10
        timeoutSeconds: 2

  - name: data-uploader
    container:
      image: localhost/data-uploader-mwe:1.0.0
      command: [ "/entrypoint.sh" ]
      env:
        - name: KG_ENDPOINT
          value: "{{inputs.parameters.kg-endpoint}}"
    inputs:
      parameters:
      - name: kg-endpoint

  - name: data-downloader
    container:
      image: localhost/data-downloader-mwe:1.0.0
      command: [ "/entrypoint.sh" ]
      env:
        - name: KG_ENDPOINT
          value: "{{inputs.parameters.kg-endpoint}}"
      volumeMounts:
        - name: out
          mountPath: "/data/outputs/"
    inputs:
      parameters:
      - name: kg-endpoint
    volumes:
      - name: out
        emptyDir: { }
    outputs:
      parameters:
      - name: results_csv
        valueFrom:
          path: "/data/outputs/results.csv"